(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

let rec iter_vars f term =
  match term with
    Term.Variable v ->
      f v
  | Term.Compound k ->
      let args = Term.compound_args k in
      for i = 0 to (Array.length args) - 1 do
	iter_vars f args.(i)
      done
  | _ ->
      ()

let is_ground term =
  try
    iter_vars (fun v -> raise Not_found) term;
    true
  with Not_found ->
    false

let is_nonvar term =
  match term with
    Term.Variable _ ->
      false
  | _ ->
      true

let varnum term =
  match term with
    Term.Variable v ->
      Term.variable_number v
  | _ ->
      raise (Failure "Variable expected.")
